# This spec file is based on the one included in the elfutils tarball

%define gpl 0
Summary: A collection of utilities and DSOs to handle compiled objects.
Name: elfutils%{_mvl_pkg_suffix}

Version: 0.108
Release: 14.0.0.%{_mvl_build_id}
Source0: elfutils-%{version}.tar.gz

%define autoconf_version 2.59
%define automake_version 1.8

Patch1:  elfutils-bswap.patch
Patch2:  elfutils-portability.patch
Patch3:  elfutils-nowarn.patch
Patch4:  elfutils-solaris_cygwin.patch
Patch5:  elfutils-mips-strip.patch
Patch6:  elfutils-libelf_po.patch
Patch7:  elfutils-autogen.patch
Patch8:  elfutils-uclibc-lintl.patch
Patch9:  elfutils-uclibc.patch
Patch10:  elfutils-elf-h.patch
Patch11:  elfutils-elfbegin.patch

%if %{gpl}
License: GPL
%else
License: OSL
%endif
Group: devel

Obsoletes: libelf libelf-devel
%if %{gpl}
Requires: binutils
%endif

# ExcludeArch: xxx

BuildRoot: %{_tmppath}/%{name}-%{_mvl_target_arch}-root
Prefix: %{_mvl_cross_target_dir}
%define _docdir %{_mvl_cross_target_dir}%{_mvl_target_doc_dir}

BuildRequires: gcc >= 3.4
BuildRequires: flex-dev >= 2.5.4
BuildRequires: bzip2-dev 

%define _gnu %{nil}
%define _programprefix eu-

%description
Elfutils is a collection of utilities, including ld (a linker),
nm (for listing symbols from object files), size (for listing the
section sizes of an object or archive file), strip (for discarding
symbols), readelf (to see the raw ELF file structures), and elflint
(to check for well-formed ELF files).  Also included are numerous
helper libraries which implement DWARF, ELF, and machine-specific ELF
handling.

%package -n elfutils-libs%{_mvl_pkg_suffix}
Summary: runtime libraries to handle compiled objects.
Group: libs
Requires: elfutils-libelf-libs%{_mvl_pkg_suffix} = %{version}-%{release}

%description -n elfutils-libs%{_mvl_pkg_suffix}
elfutils runtime libraries

%package -n elfutils-dev%{_mvl_pkg_suffix}
Summary: Development libraries to handle compiled objects.
Group: devel
%if %{gpl}
License: GPL
%else
License: OSL
%endif
Requires: elfutils-libs%{_mvl_pkg_suffix} = %{version}-%{release}
Requires: elfutils-libelf-dev%{_mvl_pkg_suffix} = %{version}-%{release}

%description -n elfutils-dev%{_mvl_pkg_suffix}
The elfutils-dev package contains the libraries to create
applications for handling compiled objects.  libebl provides some
higher-level ELF access functionality.  libdw provides access to
the DWARF debugging information.  

%package -n elfutils-libelf-libs%{_mvl_pkg_suffix}
Summary: Library to read and write ELF files.
Group: libs
Provides: libelf%{_mvl_pkg_suffix}
%if %{gpl}
License: GPL
%endif

%description -n elfutils-libelf-libs%{_mvl_pkg_suffix}
The elfutils-libelf-libs package provides a DSO which allows reading and
writing ELF files on a high level.  Third party programs depend on
this package to read internals of ELF files.  The programs of the
elfutils package use it also to generate new ELF files.

%package -n elfutils-libelf-dev%{_mvl_pkg_suffix}
Summary: Development support for libelf
Group: devel
Requires: elfutils-libelf-libs%{_mvl_pkg_suffix} = %{version}-%{release}
Conflicts: libelf-devel%{_mvl_pkg_suffix}
%if %{gpl}
License: GPL
%endif

%description -n elfutils-libelf-dev%{_mvl_pkg_suffix}
The elfutils-libelf-dev package contains the libraries to create
applications for handling compiled objects.  libelf allows you to
access the internals of the ELF object file format, so you can see the
different sections of an ELF file.

%prep
%setup -q -n elfutils-%{version}
%target_check
%target_setup

# elfutils-bswap.patch
%patch1 -p1

# elfutils-portability.patch
%patch2 -p1

# elfutils-nowarn.patch
%patch3 -p1

# elfutils-solaris_cygwin.patch
%patch4 -p1

# elfutils-mips-strip.patch
%patch5 -p1

# elfutils-libelf_po.patch
%patch6 -p1

# elfutils-autogen.patch
%patch7 -p1

# elfutils-uclibc-lintl.patch
%patch8 -p1

# elfutils-uclibc.patch
%patch9 -p1

# elfutils-elf-h.patch
%patch10 -p1

# elfutils-elfbegin.patch
%patch11 -p1


chmod +x autogen.sh

export LIBTOOLIZE=%{_mvl_target_toolprefix}libtoolize
export ACLOCAL="aclocal-1.8 -I %{_mvl_cross_target_dir}/usr/share/aclocal"
export AUTOMAKE=automake-1.8
export AUTOCONF=autoconf-2.59
export AUTOHEADER=autoheader-2.59

./autogen.sh

%build
%target_setup
%target_acplatvars

export ACLOCAL="aclocal-1.8 -I %{_mvl_cross_target_dir}/usr/share/aclocal"
export AUTOMAKE=automake-1.8
export AUTOCONF=autoconf-2.59
export AUTOHEADER=autoheader-2.59

%if "%{_mvl_uclibc}" == "yes"
export LDFLAGS="$LDFLAGS -lintl"
export LIBS="$LIBS -largp"
%endif

%target_configure \
	--program-prefix=%{_programprefix} --enable-shared
make LDFLAGS="$LDFLAGS" \
%if "%{_mvl_uclibc}" == "yes"
bin_PROGRAMS="strip"
%endif


%install
rm -rf %{buildroot}
%target_setup

%if "%{_mvl_uclibc}" == "yes"
export LDFLAGS="$LDFLAGS -lintl"
export LIBS="$LIBS -largp"
%endif

%target_makeinstall LDFLAGS="$LDFLAGS" \
%if "%{_mvl_uclibc}" == "yes"
bin_PROGRAMS="strip"
%endif


chmod +x %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/lib*.so*
%if !%{gpl}
chmod +x %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/elfutils/lib*.so*
%endif

cd ..

%if !%{gpl}
# XXX Nuke unpackaged files
{ cd %{buildroot}%{_mvl_cross_target_dir}
  rm -f .%{_mvl_target_bin_dir}/eu-ld
  rm -f .%{_mvl_target_include_dir}/elfutils/libasm.h
  rm -f .%{_mvl_target_lib_dir}/libasm-%{version}.so
  rm -f .%{_mvl_target_lib_dir}/libasm.so.1
  rm -f .%{_mvl_target_lib_dir}/libasm.so
  rm -f .%{_mvl_target_lib_dir}/libasm.a
}
%endif

%if "%{_mvl_pkg_suffix}" != ""
rm -rf %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}
rm -rf %{buildroot}%{_mvl_cross_target_dir}%{_mvl_target_include_dir}
%endif

%clean
rm -rf %{buildroot}

%if "%{_mvl_pkg_suffix}" == ""
%files
%defattr(-,root,root)
%doc README TODO
%if %{gpl}
%doc fake-src/FULL
%endif
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-strip
%if "%{_mvl_uclibc}" == ""
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-elflint
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-nm
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-readelf
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-size
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-findtextrel
%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-addr2line
%endif
%if !%{gpl}
#%{_mvl_cross_target_dir}%{_mvl_target_bin_dir}/eu-ld
%endif
%endif

%files -n elfutils-libs%{_mvl_pkg_suffix}
%defattr(-,root,root)
%if !%{gpl}
#%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libasm-%{version}.so
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libdw-%{version}.so
#%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libasm*.so.*
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libdw*.so.*
%dir %{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/elfutils
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/elfutils/lib*.so
%endif

%files -n elfutils-dev%{_mvl_pkg_suffix}
%defattr(-,root,root)
%if "%{_mvl_pkg_suffix}" == ""
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/dwarf.h
%dir %{_mvl_cross_target_dir}%{_mvl_target_include_dir}/elfutils
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/elfutils/elf-knowledge.h
%if !%{gpl}
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/elfutils/libebl.h
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/elfutils/libdw.h
%endif
%endif
%if !%{gpl}
#%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libasm.a
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libebl.a
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libdw.a
#%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libasm.so
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libdw.so
%endif

%files -n elfutils-libelf-libs%{_mvl_pkg_suffix}
%defattr(-,root,root)
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libelf-%{version}.so
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libelf*.so.*

%files -n elfutils-libelf-dev%{_mvl_pkg_suffix}
%defattr(-,root,root)
%if "%{_mvl_pkg_suffix}" == ""
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/libelf.h
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/gelf.h
%{_mvl_cross_target_dir}%{_mvl_target_include_dir}/nlist.h
%endif
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libelf.a
%{_mvl_cross_target_dir}%{_mvl_target_lib_dir}/libelf.so

%changelog
* Wed Feb 07 2007 Peter Rehley <prehley@mvista.com>
- Bug 22042 - Add patch to fix cygwin build issue.
* Mon Dec 4 2006 Khem Raj <kraj@mvista.com>
- Bug 20970: Build libelf as static library.
* Thu Nov 30 2006 Nitin Gupta <ngupta@mvista.com>
- Bug 20970: Disabling libelf.so* packaging.
* Fri  Aug 4 2006 Khem Raj <kraj@mvista.com>
- Bug 19456: Revert to 0.108.
* Thu  Aug 3 2006 Khem Raj <kraj@mvista.com>
- Bug 19456: Fix byteswap.h includes for solaris.
* Tue  Aug 1 2006 Khem Raj <kraj@mvista.com>
- Bug 19456: Fix includes for solaris.
* Mon Jul 17 2006 Khem Raj <kraj@mvista.com>
- Bug 19299: Upgrade to 0.121 version.
* Wed Jun 14 2006 Qunying Pan <qpan@mvista.com>
- Bug 17988: Update elf.h to fix build failure on cygwin.
* Thu May 11 2006 Qunying Pan <qpan@mvista.com>
- Bug 17987: Upgrade elf.h to glibc-2.4.90/elf/elf.h.

* Mon Jan 16 2006 Nitin Gupta <ngupta@mvista.com>
- Bug 15126: Fixing elfutils for HEAD uClibc targets

* Fri Dec 2 2005 Mark Hatle <mhatle@mvista.com>
- Fix a login error with dependencies on cygwin

* Wed Nov 16 2005 Mark Hatle <mhatle@mvista.com>
- If building on a system that can't generate ".so" files, disable invalid Requires

* Fri Nov 4 2005 Mark Hatle <mhatle@mvista.com>
- Copy misc/headers/{ctype.h,features.h} to common-elfutils
- munge the elf.h, ctype.h, features.h to work in common environment

* Wed Oct 26 2005 Mark Hatle <mhatle@mvista.com>
- Add in "elf.h" header for common-elfutils, required on cygwin and solaris

* Fri Oct 21 2005 Mark Hatle <mhatle@mvista.com>
- Fix elfutils (libraries and eu-strip only) to work on solaris and
  cygwin

* Fri Sep 23 2005 Mark Hatle <mhatle@mvista.com>
- Update specfile to run our autotools vs host systems

* Mon Sep 12 2005 Mark Hatle <mhatle@mvista.com>
- Update to new open source version 0.108-1

*Tue Jun 28 2005 Khem Raj <kraj@mvista.com>
- Fix 12933: Put the paranthesis around the check in the fix to avoid 
warning

*Mon Jun 27 2005 Khem Raj <kraj@mvista.com>
- Fix 12933: Redo the patch to handle SHT_MIPS_DWARF section types in 
eu-strip.

*Fri Jun 17 2005 Khem Raj <kraj@mvista.com>
- Fix 12933: handle SHT_MIPS_DWARF section types in eu-strip.

* Tue Sep 21 2004 Mark Hatle <mhatle@mvista.com>
- First MontaVista version (0.95-5).
- Original Fedora changelog is below:

@ Sun May  8 2005 Ulrich Drepper <@redhat.com> 0.108-1
- strip: fix bug introduced in last change

@ Sun May  8 2005 Ulrich Drepper <@redhat.com> 0.107-1
- readelf: improve DWARF output format
- strip: support Linux kernel modules

@ Fri Apr 29 2005 Ulrich Drepper <drepper@redhat.com> 0.107-1
- readelf: improve DWARF output format

@ Mon Apr  4 2005 Ulrich Drepper <drepper@redhat.com> 0.106-1
- libdw: Updated dwarf.h from DWARF3 speclibdw: add new funtions dwarf_f
unc_entrypc, dwarf_func_file, dwarf_func_line,dwarf_func_col, dwarf_ge
tsrc_file

@ Fri Apr  1 2005 Ulrich Drepper <drepper@redhat.com> 0.105-1
- addr2line: New program
- libdw: add new functions: dwarf_addrdie, dwarf_macro_*, dwarf_getfuncs
,dwarf_func_*.
- findtextrel: use dwarf_addrdie

@ Mon Mar 28 2005 Ulrich Drepper <drepper@redhat.com> 0.104-1
- findtextrel: New program.

@ Mon Mar 21 2005 Ulrich Drepper <drepper@redhat.com> 0.103-1
- libdw: Fix using libdw.h with gcc < 4 and C++ code.  Compiler bug.

@ Tue Feb 22 2005 Ulrich Drepper <drepper@redhat.com> 0.102-1
- More Makefile and spec file cleanups.

@ Fri Jan 16 2004 Jakub Jelinek <jakub@redhat.com> 0.94-1
- upgrade to 0.94

@ Fri Jan 16 2004 Jakub Jelinek <jakub@redhat.com> 0.93-1
- upgrade to 0.93

@ Thu Jan  8 2004 Jakub Jelinek <jakub@redhat.com> 0.92-1
- full version
- macroized spec file for GPL or OSL builds
- include only libelf under GPL plus wrapper scripts

@ Wed Jan  7 2004 Jakub Jelinek <jakub@redhat.com> 0.91-2
- macroized spec file for GPL or OSL builds

@ Wed Jan  7 2004 Ulrich Drepper <drepper@redhat.com>
- split elfutils-devel into two packages.

@ Wed Jan  7 2004 Jakub Jelinek <jakub@redhat.com> 0.91-1
- include only libelf under GPL plus wrapper scripts

@ Tue Dec 23 2003 Jeff Johnson <jbj@redhat.com> 0.89-3
- readelf, not readline, in %%description (#111214).

@ Fri Sep 26 2003 Bill Nottingham <notting@redhat.com> 0.89-1
- update to 0.89 (fix eu-strip)

@ Tue Sep 23 2003 Jakub Jelinek <jakub@redhat.com> 0.86-3
- update to 0.86 (fix eu-strip on s390x/alpha)
- libebl is an archive now; remove references to DSO

@ Mon Jul 14 2003 Jeff Johnson <jbj@redhat.com> 0.84-3
- upgrade to 0.84 (readelf/elflint improvements, rawhide bugs fixed).

@ Fri Jul 11 2003 Jeff Johnson <jbj@redhat.com> 0.83-3
- upgrade to 0.83 (fix invalid ELf handle on *.so strip, more).

@ Wed Jul  9 2003 Jeff Johnson <jbj@redhat.com> 0.82-3
- upgrade to 0.82 (strip tests fixed on big-endian).

@ Tue Jul  8 2003 Jeff Johnson <jbj@redhat.com> 0.81-3
- upgrade to 0.81 (strip excludes unused symtable entries, test borked).

@ Thu Jun 26 2003 Jeff Johnson <jbj@redhat.com> 0.80-3
- upgrade to 0.80 (debugedit changes for kernel in progress).

@ Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

@ Wed May 21 2003 Jeff Johnson <jbj@redhat.com> 0.79-2
- upgrade to 0.79 (correct formats for size_t, more of libdw "works").

@ Mon May 19 2003 Jeff Johnson <jbj@redhat.com> 0.78-2
- upgrade to 0.78 (libdwarf bugfix, libdw additions).

@ Mon Feb 24 2003 Elliot Lee <sopwith@redhat.com>
- debuginfo rebuild

@ Thu Feb 20 2003 Jeff Johnson <jbj@redhat.com> 0.76-2
- use the correct way of identifying the section via the sh_info link.

@ Sat Feb 15 2003 Jakub Jelinek <jakub@redhat.com> 0.75-2
- update to 0.75 (eu-strip -g fix)

@ Tue Feb 11 2003 Jakub Jelinek <jakub@redhat.com> 0.74-2
- update to 0.74 (fix for writing with some non-dirty sections)

@ Thu Feb  6 2003 Jeff Johnson <jbj@redhat.com> 0.73-3
- another -0.73 update (with sparc fixes).
- do "make check" in %%check, not %%install, section.

@ Mon Jan 27 2003 Jeff Johnson <jbj@redhat.com> 0.73-2
- update to 0.73 (with s390 fixes).

@ Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

@ Wed Jan 22 2003 Jakub Jelinek <jakub@redhat.com> 0.72-4
- fix arguments to gelf_getsymshndx and elf_getshstrndx
- fix other warnings
- reenable checks on s390x

@ Sat Jan 11 2003 Karsten Hopp <karsten@redhat.de> 0.72-3
- temporarily disable checks on s390x, until someone has
  time to look at it

@ Thu Dec 12 2002 Jakub Jelinek <jakub@redhat.com> 0.72-2
- update to 0.72

@ Wed Dec 11 2002 Jakub Jelinek <jakub@redhat.com> 0.71-2
- update to 0.71

@ Wed Dec 11 2002 Jeff Johnson <jbj@redhat.com> 0.69-4
- update to 0.69.
- add "make check" and segfault avoidance patch.
- elfutils-libelf needs to run ldconfig.

@ Tue Dec 10 2002 Jeff Johnson <jbj@redhat.com> 0.68-2
- update to 0.68.

@ Fri Dec  6 2002 Jeff Johnson <jbj@redhat.com> 0.67-2
- update to 0.67.

@ Tue Dec  3 2002 Jeff Johnson <jbj@redhat.com> 0.65-2
- update to 0.65.

@ Mon Dec  2 2002 Jeff Johnson <jbj@redhat.com> 0.64-2
- update to 0.64.

@ Sun Dec 1 2002 Ulrich Drepper <drepper@redhat.com> 0.64
- split packages further into elfutils-libelf

@ Sat Nov 30 2002 Jeff Johnson <jbj@redhat.com> 0.63-2
- update to 0.63.

@ Fri Nov 29 2002 Ulrich Drepper <drepper@redhat.com> 0.62
- Adjust for dropping libtool

@ Sun Nov 24 2002 Jeff Johnson <jbj@redhat.com> 0.59-2
- update to 0.59

@ Thu Nov 14 2002 Jeff Johnson <jbj@redhat.com> 0.56-2
- update to 0.56

@ Thu Nov  7 2002 Jeff Johnson <jbj@redhat.com> 0.54-2
- update to 0.54

@ Sun Oct 27 2002 Jeff Johnson <jbj@redhat.com> 0.53-2
- update to 0.53
- drop x86_64 hack, ICE fixed in gcc-3.2-11.

@ Sat Oct 26 2002 Jeff Johnson <jbj@redhat.com> 0.52-3
- get beehive to punch a rhpkg generated package.

@ Wed Oct 23 2002 Jeff Johnson <jbj@redhat.com> 0.52-2
- build in 8.0.1.
- x86_64: avoid gcc-3.2 ICE on x86_64 for now.

@ Tue Oct 22 2002 Ulrich Drepper <drepper@redhat.com> 0.52
- Add libelf-devel to conflicts for elfutils-devel

@ Mon Oct 21 2002 Ulrich Drepper <drepper@redhat.com> 0.50
- Split into runtime and devel package

@ Fri Oct 18 2002 Ulrich Drepper <drepper@redhat.com> 0.49
- integrate into official sources

@ Wed Oct 16 2002 Jeff Johnson <jbj@redhat.com> 0.46-1
- Swaddle.
